import type { Permissions } from '$lib/permissions';
import type { Cookies } from '@sveltejs/kit';

const sessions: Map<string, Permissions> = new Map();

export function addSession(permissions: Permissions): string {
	const session = 'AAA';
	sessions.set(session, permissions);
	return session;
}

export function getSession(session: string | Cookies, permissions?: number[]): Permissions | null {
	let sess: Permissions | null;
	if (typeof session == 'string') {
		sess = sessions.get(session) || null;
	} else {
		const sessionId = session.get('session');
		sess = sessionId ? sessions.get(sessionId) || null : null;
	}

	if (!sess) {
		return null;
	}
	for (const perm of permissions || []) {
		if ((sess.value & perm) == 0) {
			return null;
		}
	}
	return sess;
}
